/* D-Flip Flop that models what has been designed in cadence
 * Asynchronous reset, enable signal
 */
module adff
(
  input clk, reset, ce, din,
  output dout
);
  wire clk, reset, ce, din;
  reg dout;

  always @(negedge clk or negedge reset)
    if (~reset) dout <= 1'b1;  // reset at any time
    else if (ce) dout <= din; // new value if enabled
    else dout <= dout;        // hold
endmodule
