module sr #(parameter W = 3)
(
  input clk, reset, ce, load, din,
  input [W-1:0] din_load,
  output [W-1:0] dout
);
  wire clk, reset, ce, load, din;
  wire [W-1:0] din_load;

  wire [W-1:0] data_sel;
  wire [W-1:0] dout;

  assign data_sel[0] = load ? din_load[0] : din;

  // first flip-flop
  adff dff_begin(
    .clk(clk),
    .reset(reset),
    .ce(ce),
    .din(data_sel[0]),
    .dout(dout[0])
  );

  // generate all of the internal flip-flops
  genvar index;
  generate
  for (index=1; index < (W); index=index+1)
    begin: gen_code_label
      assign data_sel[index] = load ? din_load[index] : dout[index-1];

      adff dff(
        .clk(clk),
        .reset(reset),
        .ce(ce),
        .din(data_sel[index]),
        .dout(dout[index])
      );
    end
  endgenerate
endmodule
