`timescale 10us/1us

module sr_tb;
  parameter W = 32;
  reg clk, reset, ce, load, din;
  reg [W-1:0] din_load;
  reg reset_done;
  reg flipping;
  wire [W-1:0] dout;

  reg [W-1:0] test_val_org = 32'hdeadbeef;
  reg [W-1:0] test_val;
  reg [5:0] index;

  sr #(W) dut(
    .clk(clk),
    .reset(reset),
    .ce(ce),
    .load(load),
    .din(din),
    .din_load(din_load),
    .dout(dout)
  );

  initial begin
    $display("Shift register test bench started");
    $dumpvars(0,sr_tb);

    test_val = test_val_org;

    clk = 0;
    ce = 0;
    reset_done = 0;
    reset = 1;
    #2;
    reset = 0;
    #2;
    reset = 1;
    reset_done = 1;
    load = 0;
    din = 0;
    din_load = 0;

    index = 0;
    flipping = 0;
  end

  always clk = #1 reset_done ? ~clk : clk;

  /*always @(posedge clk) begin
    ce = 1;

    $display("Data out %h", dout);

    if (~flipping && index == 32) begin
      test_val = dout;
      flipping = 1;
      index = 0;
    end
    else if(flipping && index == 32) begin
      if (dout == test_val_org) begin
        $display("Flip flop working!");
        $finish;
      end
      else begin
        $display("Flip flop FAILED!");
        $finish;
      end
    end

    din = test_val[index];
    index = index + 1;
  end*/

  always @(posedge clk) begin
    ce = 1;
    load = 1;
    din_load = test_val;

    $display("Data out %h", dout);

    if (index) begin
      if (dout == test_val_org) begin
        $display("Flip flop load working!");
        $finish;
      end
      else begin
        $display("Flip flop load FAILED!");
        $finish;
      end
    end

    index = index + 1;
  end
endmodule
